#include <stdlib.h>
#include <stdio.h>
#include <pspkernel.h> 
#include <pspdebug.h> 
#include <pspdisplay.h> 
#include <pspctrl.h> 
#include <pspsircs.h> 
#include <string.h>
#include <psprtc.h>
#include <time.h>  

#define printf   pspDebugScreenPrintf 

typedef struct {
   char key [24];
   int value;
} KeyCfg;

struct keyType {
   char key;
   char shiftKey;
   char* keyName;
   int keyCode;
   int isAlpha;
   int isNumeric;
};

typedef struct keyType KeyType;

struct keys {
   KeyType A_KEYSTROKE;
   KeyType B_KEYSTROKE;
   KeyType C_KEYSTROKE;
   KeyType D_KEYSTROKE;
   KeyType E_KEYSTROKE;
   KeyType F_KEYSTROKE;
   KeyType G_KEYSTROKE;
   KeyType H_KEYSTROKE;
   KeyType I_KEYSTROKE;
   KeyType J_KEYSTROKE;
   KeyType K_KEYSTROKE;
   KeyType L_KEYSTROKE;
   KeyType M_KEYSTROKE;
   KeyType N_KEYSTROKE;
   KeyType O_KEYSTROKE;
   KeyType P_KEYSTROKE;
   KeyType Q_KEYSTROKE;
   KeyType R_KEYSTROKE;
   KeyType S_KEYSTROKE;
   KeyType T_KEYSTROKE;
   KeyType U_KEYSTROKE;
   KeyType V_KEYSTROKE;
   KeyType W_KEYSTROKE;
   KeyType X_KEYSTROKE;
   KeyType Y_KEYSTROKE;
   KeyType Z_KEYSTROKE;
   KeyType ONE_KEYSTROKE;
   KeyType TWO_KEYSTROKE;
   KeyType THREE_KEYSTROKE;
   KeyType FOUR_KEYSTROKE;
   KeyType FIVE_KEYSTROKE;
   KeyType SIX_KEYSTROKE;
   KeyType SEVEN_KEYSTROKE;
   KeyType EIGHT_KEYSTROKE;
   KeyType NINE_KEYSTROKE;
   KeyType ZERO_KEYSTROKE;
   KeyType ESC;
   KeyType SEMICOLON;
   KeyType COMMA;
   KeyType PERIOD;
   KeyType RIGHT_SINGLE_QUOTE;
   KeyType LEFT_SINGLE_QUOTE;
   KeyType FORWARD_SLASH;
   KeyType BACK_SLASH; 
   KeyType UP; 
   KeyType DOWN; 
   KeyType LEFT; 
   KeyType RIGHT; 
   KeyType LEFT_BRACKET;
   KeyType RIGHT_BRACKET;
   KeyType LEFT_SHIFT;
   KeyType RIGHT_SHIFT;
   KeyType LEFT_ALT;
   KeyType RIGHT_ALT;
   KeyType LEFT_CONTROL;
   KeyType RIGHT_CONTROL;
   KeyType ENTER;
   KeyType DELETE;
   KeyType TAB;
   KeyType CAPS_LOCK;
   KeyType BACKSPACE;
   KeyType SPACEBAR;
}; 

typedef struct keys KeysType; 

static KeyCfg nextKey(char* buf)
{
   KeyCfg cfgkey;
   cfgkey.value = -1;

   sscanf(buf,"%s %i",
          cfgkey.key,
          &cfgkey.value);
   return cfgkey;
}; 


static KeysType SetKeyValues(KeysType loadedKeys, KeyCfg nextVal)
{
      if(strcmp(nextVal.key, "A_KEYSTROKE") == 0){
         loadedKeys.A_KEYSTROKE.key      = 'a';
         loadedKeys.A_KEYSTROKE.shiftKey = 'A';
         loadedKeys.A_KEYSTROKE.keyName  = "A_KEYSTROKE";
         loadedKeys.A_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.A_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "B_KEYSTROKE") == 0){
         loadedKeys.B_KEYSTROKE.key      = 'b';
         loadedKeys.B_KEYSTROKE.shiftKey = 'B';
         loadedKeys.B_KEYSTROKE.keyName  = "B_KEYSTROKE";
         loadedKeys.B_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.B_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "C_KEYSTROKE") == 0){
         loadedKeys.C_KEYSTROKE.key      = 'c';
         loadedKeys.C_KEYSTROKE.shiftKey = 'C';
         loadedKeys.C_KEYSTROKE.keyName  = "C_KEYSTROKE";
         loadedKeys.C_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.C_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "D_KEYSTROKE") == 0){
         loadedKeys.D_KEYSTROKE.key      = 'd';
         loadedKeys.D_KEYSTROKE.shiftKey = 'D';
         loadedKeys.D_KEYSTROKE.keyName  = "D_KEYSTROKE";
         loadedKeys.D_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.D_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "E_KEYSTROKE") == 0){
         loadedKeys.E_KEYSTROKE.key      = 'e';
         loadedKeys.E_KEYSTROKE.shiftKey = 'E';
         loadedKeys.E_KEYSTROKE.keyName  = "E_KEYSTROKE";
         loadedKeys.E_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.E_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "F_KEYSTROKE") == 0){
         loadedKeys.F_KEYSTROKE.key      = 'f';
         loadedKeys.F_KEYSTROKE.shiftKey = 'F';
         loadedKeys.F_KEYSTROKE.keyName  = "F_KEYSTROKE";
         loadedKeys.F_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.F_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "G_KEYSTROKE") == 0){
         loadedKeys.G_KEYSTROKE.key      = 'g';
         loadedKeys.G_KEYSTROKE.shiftKey = 'G';
         loadedKeys.G_KEYSTROKE.keyName  = "G_KEYSTROKE";
         loadedKeys.G_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.G_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "H_KEYSTROKE") == 0){
         loadedKeys.H_KEYSTROKE.key      = 'h';
         loadedKeys.H_KEYSTROKE.shiftKey = 'H';
         loadedKeys.H_KEYSTROKE.keyName  = "H_KEYSTROKE";
         loadedKeys.H_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.H_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "I_KEYSTROKE") == 0){
         loadedKeys.I_KEYSTROKE.key      = 'i';
         loadedKeys.I_KEYSTROKE.shiftKey = 'I';
         loadedKeys.I_KEYSTROKE.keyName  = "I_KEYSTROKE";
         loadedKeys.I_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.I_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "J_KEYSTROKE") == 0){
         loadedKeys.J_KEYSTROKE.key      = 'j';
         loadedKeys.J_KEYSTROKE.shiftKey = 'J';
         loadedKeys.J_KEYSTROKE.keyName  = "J_KEYSTROKE";
         loadedKeys.J_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.J_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "K_KEYSTROKE") == 0){
         loadedKeys.K_KEYSTROKE.key      = 'k';
         loadedKeys.K_KEYSTROKE.shiftKey = 'K';
         loadedKeys.K_KEYSTROKE.keyName  = "K_KEYSTROKE";
         loadedKeys.K_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.K_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "L_KEYSTROKE") == 0){
         loadedKeys.L_KEYSTROKE.key      = 'l';
         loadedKeys.L_KEYSTROKE.shiftKey = 'L';
         loadedKeys.L_KEYSTROKE.keyName  = "L_KEYSTROKE";
         loadedKeys.L_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.L_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "M_KEYSTROKE") == 0){
         loadedKeys.M_KEYSTROKE.key      = 'm';
         loadedKeys.M_KEYSTROKE.shiftKey = 'M';
         loadedKeys.M_KEYSTROKE.keyName  = "M_KEYSTROKE";
         loadedKeys.M_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.M_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "N_KEYSTROKE") == 0){
         loadedKeys.N_KEYSTROKE.key      = 'n';
         loadedKeys.N_KEYSTROKE.shiftKey = 'N';
         loadedKeys.N_KEYSTROKE.keyName  = "N_KEYSTROKE";
         loadedKeys.N_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.N_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "O_KEYSTROKE") == 0){
         loadedKeys.O_KEYSTROKE.key      = 'o';
         loadedKeys.O_KEYSTROKE.shiftKey = 'O';
         loadedKeys.O_KEYSTROKE.keyName  = "O_KEYSTROKE";
         loadedKeys.O_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.O_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "P_KEYSTROKE") == 0){
         loadedKeys.P_KEYSTROKE.key      = 'p';
         loadedKeys.P_KEYSTROKE.shiftKey = 'P';
         loadedKeys.P_KEYSTROKE.keyName  = "P_KEYSTROKE";
         loadedKeys.P_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.P_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "Q_KEYSTROKE") == 0){
         loadedKeys.Q_KEYSTROKE.key      = 'q';
         loadedKeys.Q_KEYSTROKE.shiftKey = 'Q';
         loadedKeys.Q_KEYSTROKE.keyName  = "Q_KEYSTROKE";
         loadedKeys.Q_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.Q_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "R_KEYSTROKE") == 0){
         loadedKeys.R_KEYSTROKE.key      = 'r';
         loadedKeys.R_KEYSTROKE.shiftKey = 'R';
         loadedKeys.R_KEYSTROKE.keyName  = "R_KEYSTROKE";
         loadedKeys.R_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.R_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "S_KEYSTROKE") == 0){
         loadedKeys.S_KEYSTROKE.key      = 's';
         loadedKeys.S_KEYSTROKE.shiftKey = 'S';
         loadedKeys.S_KEYSTROKE.keyName  = "S_KEYSTROKE";
         loadedKeys.S_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.S_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "T_KEYSTROKE") == 0){
         loadedKeys.T_KEYSTROKE.key      = 't';
         loadedKeys.T_KEYSTROKE.shiftKey = 'T';
         loadedKeys.T_KEYSTROKE.keyName  = "T_KEYSTROKE";
         loadedKeys.T_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.T_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "U_KEYSTROKE") == 0){
         loadedKeys.U_KEYSTROKE.key      = 'u';
         loadedKeys.U_KEYSTROKE.shiftKey = 'U';
         loadedKeys.U_KEYSTROKE.keyName  = "U_KEYSTROKE";
         loadedKeys.U_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.U_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "V_KEYSTROKE") == 0){
         loadedKeys.V_KEYSTROKE.key      = 'v';
         loadedKeys.V_KEYSTROKE.shiftKey = 'V';
         loadedKeys.V_KEYSTROKE.keyName  = "V_KEYSTROKE";
         loadedKeys.V_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.V_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "W_KEYSTROKE") == 0){
         loadedKeys.W_KEYSTROKE.key      = 'w';
         loadedKeys.W_KEYSTROKE.shiftKey = 'W';
         loadedKeys.W_KEYSTROKE.keyName  = "W_KEYSTROKE";
         loadedKeys.W_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.W_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "X_KEYSTROKE") == 0){
         loadedKeys.X_KEYSTROKE.key      = 'x';
         loadedKeys.X_KEYSTROKE.shiftKey = 'X';
         loadedKeys.X_KEYSTROKE.keyName  = "X_KEYSTROKE";
         loadedKeys.X_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.X_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "Y_KEYSTROKE") == 0){
         loadedKeys.Y_KEYSTROKE.key      = 'y';
         loadedKeys.Y_KEYSTROKE.shiftKey = 'Y';
         loadedKeys.Y_KEYSTROKE.keyName  = "Y_KEYSTROKE";
         loadedKeys.Y_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.Y_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "Z_KEYSTROKE") == 0){
         loadedKeys.Z_KEYSTROKE.key      = 'z';
         loadedKeys.Z_KEYSTROKE.shiftKey = 'Z';
         loadedKeys.Z_KEYSTROKE.keyName  = "Z_KEYSTROKE";
         loadedKeys.Z_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.Z_KEYSTROKE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "ONE_KEYSTROKE") == 0){
         loadedKeys.ONE_KEYSTROKE.key      = '1';
         loadedKeys.ONE_KEYSTROKE.shiftKey = '!';
         loadedKeys.ONE_KEYSTROKE.keyName  = "ONE_KEYSTROKE";
         loadedKeys.ONE_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.ONE_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "TWO_KEYSTROKE") == 0){
         loadedKeys.TWO_KEYSTROKE.key      = '2';
         loadedKeys.TWO_KEYSTROKE.shiftKey = '@';
         loadedKeys.TWO_KEYSTROKE.keyName  = "TWO_KEYSTROKE";
         loadedKeys.TWO_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.TWO_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "THREE_KEYSTROKE") == 0){
         loadedKeys.THREE_KEYSTROKE.key      = '3';
         loadedKeys.THREE_KEYSTROKE.shiftKey = '#';
         loadedKeys.THREE_KEYSTROKE.keyName  = "THREE_KEYSTROKE";
         loadedKeys.THREE_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.THREE_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "FOUR_KEYSTROKE") == 0){
         loadedKeys.FOUR_KEYSTROKE.key      = '4';
         loadedKeys.FOUR_KEYSTROKE.shiftKey = '$';
         loadedKeys.FOUR_KEYSTROKE.keyName  = "FOUR_KEYSTROKE";
         loadedKeys.FOUR_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.FOUR_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "FIVE_KEYSTROKE") == 0){
         loadedKeys.FIVE_KEYSTROKE.key      = '5';
         loadedKeys.FIVE_KEYSTROKE.shiftKey = '%';
         loadedKeys.FIVE_KEYSTROKE.keyName  = "FIVE_KEYSTROKE";
         loadedKeys.FIVE_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.FIVE_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "SIX_KEYSTROKE") == 0){
         loadedKeys.SIX_KEYSTROKE.key      = '6';
         loadedKeys.SIX_KEYSTROKE.shiftKey = '^';
         loadedKeys.SIX_KEYSTROKE.keyName  = "SIX_KEYSTROKE";
         loadedKeys.SIX_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.SIX_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "SEVEN_KEYSTROKE") == 0){
         loadedKeys.SEVEN_KEYSTROKE.key      = '7';
         loadedKeys.SEVEN_KEYSTROKE.shiftKey = '&';
         loadedKeys.SEVEN_KEYSTROKE.keyName  = "SEVEN_KEYSTROKE";
         loadedKeys.SEVEN_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.SEVEN_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "EIGHT_KEYSTROKE") == 0){
         loadedKeys.EIGHT_KEYSTROKE.key      = '8';
         loadedKeys.EIGHT_KEYSTROKE.shiftKey = '*';
         loadedKeys.EIGHT_KEYSTROKE.keyName  = "EIGHT_KEYSTROKE";
         loadedKeys.EIGHT_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.EIGHT_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "NINE_KEYSTROKE") == 0){
         loadedKeys.NINE_KEYSTROKE.key      = '9';
         loadedKeys.NINE_KEYSTROKE.shiftKey = '(';
         loadedKeys.NINE_KEYSTROKE.keyName  = "NINE_KEYSTROKE";
         loadedKeys.NINE_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.NINE_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "ZERO_KEYSTROKE") == 0){
         loadedKeys.ZERO_KEYSTROKE.key      = '0';
         loadedKeys.ZERO_KEYSTROKE.shiftKey = ')';
         loadedKeys.ZERO_KEYSTROKE.keyName  = "ZERO_KEYSTROKE";
         loadedKeys.ZERO_KEYSTROKE.keyCode  = nextVal.value;
         loadedKeys.ZERO_KEYSTROKE.isNumeric = 1;
      }
      else if(strcmp(nextVal.key, "ESC") == 0){
         loadedKeys.ESC.keyName  = "ESC";
         loadedKeys.ESC.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "SEMICOLON") == 0){
         loadedKeys.SEMICOLON.key      = ';';
         loadedKeys.SEMICOLON.shiftKey = ':';
         loadedKeys.SEMICOLON.keyName  = "SEMICOLON";
         loadedKeys.SEMICOLON.keyCode  = nextVal.value;
         loadedKeys.SEMICOLON.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "COMMA") == 0){
         loadedKeys.COMMA.key      = ',';
         loadedKeys.COMMA.shiftKey = '<';
         loadedKeys.COMMA.keyName  = "COMMA";
         loadedKeys.COMMA.keyCode  = nextVal.value;
         loadedKeys.COMMA.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "PERIOD") == 0){
         loadedKeys.PERIOD.key      = '.';
         loadedKeys.PERIOD.shiftKey = '>';
         loadedKeys.PERIOD.keyName  = "PERIOD";
         loadedKeys.PERIOD.keyCode  = nextVal.value;
         loadedKeys.PERIOD.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "RIGHT_SINGLE_QUOTE") == 0){
         loadedKeys.RIGHT_SINGLE_QUOTE.key      = '\'';
         loadedKeys.RIGHT_SINGLE_QUOTE.shiftKey = '\"';
         loadedKeys.RIGHT_SINGLE_QUOTE.keyName  = "RIGHT_SINGLE_QUOTE";
         loadedKeys.RIGHT_SINGLE_QUOTE.keyCode  = nextVal.value;
         loadedKeys.RIGHT_SINGLE_QUOTE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "LEFT_SINGLE_QUOTE") == 0){
         loadedKeys.LEFT_SINGLE_QUOTE.key      = '`';
         loadedKeys.LEFT_SINGLE_QUOTE.shiftKey = '~';
         loadedKeys.LEFT_SINGLE_QUOTE.keyName  = "LEFT_SINGLE_QUOTE";
         loadedKeys.LEFT_SINGLE_QUOTE.keyCode  = nextVal.value;
         loadedKeys.LEFT_SINGLE_QUOTE.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "FORWARD_SLASH") == 0){
         loadedKeys.FORWARD_SLASH.key      = '/';
         loadedKeys.FORWARD_SLASH.shiftKey = '?';
         loadedKeys.FORWARD_SLASH.keyName  = "FORWARD_SLASH";
         loadedKeys.FORWARD_SLASH.keyCode  = nextVal.value;
         loadedKeys.FORWARD_SLASH.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "BACK_SLASH") == 0){ 
         loadedKeys.BACK_SLASH.key      = '\\';
         loadedKeys.BACK_SLASH.shiftKey = '|';
         loadedKeys.BACK_SLASH.keyName  = "BACK_SLASH";
         loadedKeys.BACK_SLASH.keyCode  = nextVal.value;
         loadedKeys.BACK_SLASH.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "UP") == 0){ 
         loadedKeys.UP.keyName  = "UP";
         loadedKeys.UP.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "DOWN") == 0){ 
         loadedKeys.DOWN.keyName  = "DOWN";
         loadedKeys.DOWN.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "LEFT") == 0){ 
         loadedKeys.LEFT.keyName  = "LEFT";
         loadedKeys.LEFT.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "RIGHT") == 0){ 
         loadedKeys.RIGHT.keyName  = "RIGHT";
         loadedKeys.RIGHT.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "LEFT_BRACKET") == 0){
         loadedKeys.LEFT_BRACKET.key      = '[';
         loadedKeys.LEFT_BRACKET.shiftKey = '{';
         loadedKeys.LEFT_BRACKET.keyName  = "LEFT_BRACKET";
         loadedKeys.LEFT_BRACKET.keyCode  = nextVal.value;
         loadedKeys.LEFT_BRACKET.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "RIGHT_BRACKET") == 0){
         loadedKeys.RIGHT_BRACKET.key      = ']';
         loadedKeys.RIGHT_BRACKET.shiftKey = '}';
         loadedKeys.RIGHT_BRACKET.keyName  = "RIGHT_BRACKET";
         loadedKeys.RIGHT_BRACKET.keyCode  = nextVal.value;
         loadedKeys.RIGHT_BRACKET.isAlpha  = 1;
      }
      else if(strcmp(nextVal.key, "LEFT_SHIFT") == 0){
         loadedKeys.LEFT_SHIFT.keyName  = "LEFT_SHIFT";
         loadedKeys.LEFT_SHIFT.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "RIGHT_SHIFT") == 0){
         loadedKeys.RIGHT_SHIFT.keyName  = "RIGHT_SHIFT";
         loadedKeys.RIGHT_SHIFT.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "LEFT_ALT") == 0){
         loadedKeys.LEFT_ALT.keyName  = "LEFT_ALT";
         loadedKeys.LEFT_ALT.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "RIGHT_ALT") == 0){
         loadedKeys.RIGHT_ALT.keyName  = "RIGHT_ALT";
         loadedKeys.RIGHT_ALT.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "LEFT_CONTROL") == 0){
         loadedKeys.LEFT_CONTROL.keyName  = "LEFT_CONTROL";
         loadedKeys.LEFT_CONTROL.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "RIGHT_CONTROL") == 0){
         loadedKeys.RIGHT_CONTROL.keyName  = "RIGHT_CONTROL";
         loadedKeys.RIGHT_CONTROL.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "ENTER") == 0){
         loadedKeys.SPACEBAR.key      = '\n';
         loadedKeys.SPACEBAR.shiftKey = '\n';
         loadedKeys.ENTER.keyName  = "ENTER";
         loadedKeys.ENTER.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "DELETE") == 0){
         loadedKeys.DELETE.keyName  = "DELETE";
         loadedKeys.DELETE.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "TAB") == 0){
         loadedKeys.TAB.keyName  = "TAB";
         loadedKeys.TAB.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "CAPS_LOCK") == 0){
         loadedKeys.CAPS_LOCK.keyName  = "CAPS_LOCK";
         loadedKeys.CAPS_LOCK.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "BACKSPACE") == 0){
         loadedKeys.BACKSPACE.keyName  = "BACKSPACE";
         loadedKeys.BACKSPACE.keyCode  = nextVal.value;
      }
      else if(strcmp(nextVal.key, "SPACEBAR") == 0){
         loadedKeys.SPACEBAR.key      = ' ';
         loadedKeys.SPACEBAR.shiftKey = ' ';
         loadedKeys.SPACEBAR.keyName  = "SPACEBAR";
         loadedKeys.SPACEBAR.keyCode  = nextVal.value;
         loadedKeys.SPACEBAR.isAlpha  = 1;
      }
  
   return loadedKeys; 
} 

KeyType GetKeyPressed(KeysType keys, int keyCode)
{
    KeyType undef;
    undef.keyCode = -1;
    undef.keyName = "UNDEFINED";
    undef.key = ' ';
    undef.shiftKey = ' ';
    undef.isAlpha = 0;
    undef.isNumeric = 0;
      if(keyCode == keys.A_KEYSTROKE.keyCode) return keys.A_KEYSTROKE;
      if(keyCode == keys.B_KEYSTROKE.keyCode) return keys.B_KEYSTROKE;
      if(keyCode == keys.C_KEYSTROKE.keyCode) return keys.C_KEYSTROKE;
      if(keyCode == keys.D_KEYSTROKE.keyCode) return keys.D_KEYSTROKE;
      if(keyCode == keys.E_KEYSTROKE.keyCode) return keys.E_KEYSTROKE;
      if(keyCode == keys.F_KEYSTROKE.keyCode) return keys.F_KEYSTROKE;
      if(keyCode == keys.G_KEYSTROKE.keyCode) return keys.G_KEYSTROKE;
      if(keyCode == keys.H_KEYSTROKE.keyCode) return keys.H_KEYSTROKE;
      if(keyCode == keys.I_KEYSTROKE.keyCode) return keys.I_KEYSTROKE;
      if(keyCode == keys.J_KEYSTROKE.keyCode) return keys.J_KEYSTROKE;
      if(keyCode == keys.K_KEYSTROKE.keyCode) return keys.K_KEYSTROKE;
      if(keyCode == keys.L_KEYSTROKE.keyCode) return keys.L_KEYSTROKE;
      if(keyCode == keys.M_KEYSTROKE.keyCode) return keys.M_KEYSTROKE;
      if(keyCode == keys.N_KEYSTROKE.keyCode) return keys.N_KEYSTROKE;
      if(keyCode == keys.O_KEYSTROKE.keyCode) return keys.O_KEYSTROKE;
      if(keyCode == keys.P_KEYSTROKE.keyCode) return keys.P_KEYSTROKE;
      if(keyCode == keys.Q_KEYSTROKE.keyCode) return keys.Q_KEYSTROKE;
      if(keyCode == keys.R_KEYSTROKE.keyCode) return keys.R_KEYSTROKE;
      if(keyCode == keys.S_KEYSTROKE.keyCode) return keys.S_KEYSTROKE;
      if(keyCode == keys.T_KEYSTROKE.keyCode) return keys.T_KEYSTROKE;
      if(keyCode == keys.U_KEYSTROKE.keyCode) return keys.U_KEYSTROKE;
      if(keyCode == keys.V_KEYSTROKE.keyCode) return keys.V_KEYSTROKE;
      if(keyCode == keys.W_KEYSTROKE.keyCode) return keys.W_KEYSTROKE;
      if(keyCode == keys.X_KEYSTROKE.keyCode) return keys.X_KEYSTROKE;
      if(keyCode == keys.Y_KEYSTROKE.keyCode) return keys.Y_KEYSTROKE;
      if(keyCode == keys.Z_KEYSTROKE.keyCode) return keys.Z_KEYSTROKE;
      if(keyCode == keys.ONE_KEYSTROKE.keyCode) return keys.ONE_KEYSTROKE;
      if(keyCode == keys.TWO_KEYSTROKE.keyCode) return keys.TWO_KEYSTROKE;
      if(keyCode == keys.THREE_KEYSTROKE.keyCode) return keys.THREE_KEYSTROKE;
      if(keyCode == keys.FOUR_KEYSTROKE.keyCode) return keys.FOUR_KEYSTROKE;
      if(keyCode == keys.FIVE_KEYSTROKE.keyCode) return keys.FIVE_KEYSTROKE;
      if(keyCode == keys.SIX_KEYSTROKE.keyCode) return keys.SIX_KEYSTROKE;
      if(keyCode == keys.SEVEN_KEYSTROKE.keyCode) return keys.SEVEN_KEYSTROKE;
      if(keyCode == keys.EIGHT_KEYSTROKE.keyCode) return keys.EIGHT_KEYSTROKE;
      if(keyCode == keys.NINE_KEYSTROKE.keyCode) return keys.NINE_KEYSTROKE;
      if(keyCode == keys.ZERO_KEYSTROKE.keyCode) return keys.ZERO_KEYSTROKE;
      if(keyCode == keys.ESC.keyCode) return keys.ESC;
      if(keyCode == keys.SEMICOLON.keyCode) return keys.SEMICOLON;
      if(keyCode == keys.COMMA.keyCode) return keys.COMMA;
      if(keyCode == keys.PERIOD.keyCode) return keys.PERIOD;
      if(keyCode == keys.RIGHT_SINGLE_QUOTE.keyCode) return keys.RIGHT_SINGLE_QUOTE;
      if(keyCode == keys.LEFT_SINGLE_QUOTE.keyCode) return keys.LEFT_SINGLE_QUOTE;
      if(keyCode == keys.FORWARD_SLASH.keyCode) return keys.FORWARD_SLASH;
      if(keyCode == keys.BACK_SLASH.keyCode) return keys.BACK_SLASH; 
      if(keyCode == keys.UP.keyCode) return keys.UP; 
      if(keyCode == keys.DOWN.keyCode) return keys.DOWN; 
      if(keyCode == keys.LEFT.keyCode) return keys.LEFT; 
      if(keyCode == keys.RIGHT.keyCode) return keys.RIGHT; 
      if(keyCode == keys.LEFT_BRACKET.keyCode) return keys.LEFT_BRACKET;
      if(keyCode == keys.RIGHT_BRACKET.keyCode) return keys.RIGHT_BRACKET;
      if(keyCode == keys.LEFT_SHIFT.keyCode) return keys.LEFT_SHIFT;
      if(keyCode == keys.RIGHT_SHIFT.keyCode) return keys.RIGHT_SHIFT;
      if(keyCode == keys.LEFT_ALT.keyCode) return keys.LEFT_ALT;
      if(keyCode == keys.RIGHT_ALT.keyCode) return keys.RIGHT_ALT;
      if(keyCode == keys.LEFT_CONTROL.keyCode) return keys.LEFT_CONTROL;
      if(keyCode == keys.RIGHT_CONTROL.keyCode) return keys.RIGHT_CONTROL;
      if(keyCode == keys.ENTER.keyCode) return keys.ENTER;
      if(keyCode == keys.DELETE.keyCode) return keys.DELETE;
      if(keyCode == keys.TAB.keyCode) return keys.TAB;
      if(keyCode == keys.CAPS_LOCK.keyCode) return keys.CAPS_LOCK;
      if(keyCode == keys.BACKSPACE.keyCode) return keys.BACKSPACE;
      if(keyCode == keys.SPACEBAR.keyCode) return keys.SPACEBAR;
      return undef;
}

KeysType LoadKeyValues(char* cfgFile)
{
   KeysType loadedKeys;

   FILE * pFile;
   long lSize;
   char * buffer;
   char c;
   long wc = 0;

   //printf("Opening File: %s\n",cfgFile);
   pFile = fopen(cfgFile, "rb");

   if(pFile == NULL)
   {
      printf("FILE %s DOES NOT EXIST!", cfgFile); 
   }
   else
   {
      //printf("Opened File %s Successfully\n",cfgFile);
      fseek (pFile, 0, SEEK_END);
      lSize = ftell (pFile);
      rewind(pFile);
      //printf("Got File Length: %i\n", lSize);
      buffer = (char*)malloc(lSize);
      if(buffer == NULL) printf ( "NULL File Buffer!" );

      fread(buffer,1,lSize,pFile);

       char* bufline = buffer;
       while ((bufline = strchr (bufline, '\n')) != NULL) {
            bufline = bufline + 1;
            wc++;
	    }
    
      //printf("Counted Lines: %i\n",wc);
       
      fclose(pFile);
      //printf("Closed Config File\n");
      int num = 0;
      while(num < wc)
      {
         KeyCfg nextVal = nextKey(buffer);

         //process nextVal
         loadedKeys = SetKeyValues(loadedKeys, nextVal); 

         int doloop = 1;
         int numtoskip = 0;         
  
         //Strip last value read
         buffer = strchr (buffer, '\n');
         buffer = buffer + 1;
         
         num++;
      }
      //printf("Loaded all Keys Successfully!\n"); 
   }
    //printf("Returning...\n");
    return loadedKeys; 

};

